/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables.records;


import de.ship.db.enums.EnumFormtype;
import de.ship.db.enums.EnumInputlayout;
import de.ship.db.tables.TInputWebform;

import java.time.LocalDateTime;

import org.jooq.Record1;
import org.jooq.impl.UpdatableRecordImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TInputWebformRecord extends UpdatableRecordImpl<TInputWebformRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * Setter for <code>common_dd.t_input_webform.lastchange</code>.
     */
    public void setLastchange(LocalDateTime value) {
        set(0, value);
    }

    /**
     * Getter for <code>common_dd.t_input_webform.lastchange</code>.
     */
    public LocalDateTime getLastchange() {
        return (LocalDateTime) get(0);
    }

    /**
     * Setter for <code>common_dd.t_input_webform.fk_form</code>. foreign key to
     * key_element of referenced form
     */
    public void setFkForm(Integer value) {
        set(1, value);
    }

    /**
     * Getter for <code>common_dd.t_input_webform.fk_form</code>. foreign key to
     * key_element of referenced form
     */
    public Integer getFkForm() {
        return (Integer) get(1);
    }

    /**
     * Setter for <code>common_dd.t_input_webform.inputlayout</code>. topdown,
     * xypos, ...
     */
    public void setInputlayout(EnumInputlayout value) {
        set(2, value);
    }

    /**
     * Getter for <code>common_dd.t_input_webform.inputlayout</code>. topdown,
     * xypos, ...
     */
    public EnumInputlayout getInputlayout() {
        return (EnumInputlayout) get(2);
    }

    /**
     * Setter for <code>common_dd.t_input_webform.form_order</code>. absolute
     * order of form
     */
    public void setFormOrder(Integer value) {
        set(3, value);
    }

    /**
     * Getter for <code>common_dd.t_input_webform.form_order</code>. absolute
     * order of form
     */
    public Integer getFormOrder() {
        return (Integer) get(3);
    }

    /**
     * Setter for <code>common_dd.t_input_webform.fk_study_generation</code>.
     * foreign key to key_element of referenced study
     */
    public void setFkStudyGeneration(Integer value) {
        set(4, value);
    }

    /**
     * Getter for <code>common_dd.t_input_webform.fk_study_generation</code>.
     * foreign key to key_element of referenced study
     */
    public Integer getFkStudyGeneration() {
        return (Integer) get(4);
    }

    /**
     * Setter for <code>common_dd.t_input_webform.ignore_closed_visits</code>.
     * allow form filling on closed visits
     */
    public void setIgnoreClosedVisits(Boolean value) {
        set(5, value);
    }

    /**
     * Getter for <code>common_dd.t_input_webform.ignore_closed_visits</code>.
     * allow form filling on closed visits
     */
    public Boolean getIgnoreClosedVisits() {
        return (Boolean) get(5);
    }

    /**
     * Setter for <code>common_dd.t_input_webform.min_obs</code>. null
     * (default): no minimum number of observations for form needed, n&gt;0: n
     * number of observations needed to be valid
     */
    public void setMinObs(Integer value) {
        set(6, value);
    }

    /**
     * Getter for <code>common_dd.t_input_webform.min_obs</code>. null
     * (default): no minimum number of observations for form needed, n&gt;0: n
     * number of observations needed to be valid
     */
    public Integer getMinObs() {
        return (Integer) get(6);
    }

    /**
     * Setter for <code>common_dd.t_input_webform.max_obs</code>. null
     * (default): no maximum number of observations for form, n&gt;0: maximumn
     * of n observations  for this form allowed
     */
    public void setMaxObs(Integer value) {
        set(7, value);
    }

    /**
     * Getter for <code>common_dd.t_input_webform.max_obs</code>. null
     * (default): no maximum number of observations for form, n&gt;0: maximumn
     * of n observations  for this form allowed
     */
    public Integer getMaxObs() {
        return (Integer) get(7);
    }

    /**
     * Setter for <code>common_dd.t_input_webform.user_owns</code>. false: any
     * user can edit the form of the observation created by another user, true:
     * only the creator of the form observation may edit it
     */
    public void setUserOwns(Boolean value) {
        set(8, value);
    }

    /**
     * Getter for <code>common_dd.t_input_webform.user_owns</code>. false: any
     * user can edit the form of the observation created by another user, true:
     * only the creator of the form observation may edit it
     */
    public Boolean getUserOwns() {
        return (Boolean) get(8);
    }

    /**
     * Setter for <code>common_dd.t_input_webform.fk_reference</code>. reference
     */
    public void setFkReference(String value) {
        set(9, value);
    }

    /**
     * Getter for <code>common_dd.t_input_webform.fk_reference</code>. reference
     */
    public String getFkReference() {
        return (String) get(9);
    }

    /**
     * Setter for <code>common_dd.t_input_webform.form_type</code>.
     */
    public void setFormType(EnumFormtype value) {
        set(10, value);
    }

    /**
     * Getter for <code>common_dd.t_input_webform.form_type</code>.
     */
    public EnumFormtype getFormType() {
        return (EnumFormtype) get(10);
    }

    // -------------------------------------------------------------------------
    // Primary key information
    // -------------------------------------------------------------------------

    @Override
    public Record1<Integer> key() {
        return (Record1) super.key();
    }

    // -------------------------------------------------------------------------
    // Constructors
    // -------------------------------------------------------------------------

    /**
     * Create a detached TInputWebformRecord
     */
    public TInputWebformRecord() {
        super(TInputWebform.T_INPUT_WEBFORM);
    }

    /**
     * Create a detached, initialised TInputWebformRecord
     */
    public TInputWebformRecord(LocalDateTime lastchange, Integer fkForm, EnumInputlayout inputlayout, Integer formOrder, Integer fkStudyGeneration, Boolean ignoreClosedVisits, Integer minObs, Integer maxObs, Boolean userOwns, String fkReference, EnumFormtype formType) {
        super(TInputWebform.T_INPUT_WEBFORM);

        setLastchange(lastchange);
        setFkForm(fkForm);
        setInputlayout(inputlayout);
        setFormOrder(formOrder);
        setFkStudyGeneration(fkStudyGeneration);
        setIgnoreClosedVisits(ignoreClosedVisits);
        setMinObs(minObs);
        setMaxObs(maxObs);
        setUserOwns(userOwns);
        setFkReference(fkReference);
        setFormType(formType);
        resetChangedOnNotNull();
    }
}
